type category = [ `base | `godi | `apps | `conf ]
type relop = [`lt | `gt | `le | `ge | `eq ]
type options = [ `configure | `bmake | `opt | `htdoc ]
type dep = (category * string * (relop * string) option)
(*          category , name   , (relop , version)  *)

val string_of_relop : relop -> string
val string_of_category : category -> string
val string_of_dep : dep -> string

type t =
    {
      package: string; (* without category- *)
      version: string;
      revision: int;
      category: category;
      depends: dep list;
      build_depends: dep list;
      sources_site: string;
      sources_basename: string;
      sources_extension: string;
      homepage: string;
      maintainer: string;
      short_desc: string;
      long_desc: string;
      options: options list;
      docfiles: string list;
    }

val sample : t

(* the entire makefile for the given control information as a giant string *)
val makefile : t -> string

(* the contents of the DESCR file as a string *)
val descr : t -> string

(* writes out the generated package into a directory with the same name
   as its control.package. *)
val write_package : string -> t -> unit
